' PhotonRT2.bas for FilmStar DESIGN and MEASURE
' Copyright 2019-2020 FTG Software Associates
' Version 05/08/20...Get angle from 'Measurements' sheet
' Problem? Send Photon RT xls files to FTG for analysis

Option Explicit
DefLng i-N
DefSng A-H, O-Z
Option Base 1

Dim PhotFile$, PhotPath$, PhotName$, PhotSheet$

Const PhotPath0$ = "C:\Winfilm\PhotonRT"
Const MeasSheet$ = "Measurements"

Sub Main
    Dim i, j%, j1%, k%, PhotName$, kCol%, kRow, nRows, nCols%, sz$, t$
    Dim file$, ang(), det(), plz$(), typ$(), nSmp
    PhotPath$ = IniString("PhotonRT", "XlsPath")
    If PhotPath$ = "" Then PhotPath$ = PhotPath0$
    file$ = GetFilePath$(, "xls", PhotPath$, "Open Photon RT spectrum", 0)
    FilePath file$, PhotPath$, PhotFile$, True
    WriteIniString "PhotonRT", "XlsPath", PhotPath$
    If Not XLopen(file$, MeasSheet$) Then End
    XLinfo nRows, nCols
    nSmp = nCols - 1
    ReDim ang(nSmp), det(nSmp), plz$(nSmp), typ$(nSmp)
    For i = 1 To nSmp
        kCol = i + 1
        sz$ = XLcell(1, kCol)
        typ$(i) = Split(sz$, " ")(0)
        t$ = Split(sz$, " ")(1)
        ang(i) = Val(Split(t$, "/")(0))
        det(i) = Val(Split(t$, "/")(1))
        plz$(i) = Split(sz$, " ")(2)
        If plz$(i) = "Avg" Then plz$(i) = "R"
    Next i
    ReDim xSheet(nRows, nCols) As Variant
    For i = 1 To nRows
        For j = 1 To nCols
            xSheet(i, j) = XLcell(i, j)
        Next j
    Next i
    XLclose
    XLnew nRows, nCols, "Photon RT"
    Select Case xSheet(1, 1)
    Case "Wavelength, nm"
        XLwrite 1, 1, "W (nm)"
    End Select
    For j = 2 To nCols          ' j FilmStar column
        kCol = j
        i = j - 1
        XLwrite 1, j, typ$(i) & plz$(i) & " " & CStr(ang(i)) & " " & CStr(det(i))
    Next j
    For i = 2 To nRows
        For j =  1 To nCols
            XLwrite i, j, CStr(xSheet(i, j)), 4
        Next j
    Next i
    t$ = PhotPath0$ & "\" & PhotFile$ & ".xlsx"
    On Error Resume Next
    Kill t$
    XLsave t$
    XLclose
End Sub

Function fnPath$(ByVal p$)
    On Error Resume Next
    If Trim$(p$)= "" Then
        fnPath$ = ""
    Else
        If Mid$(p$, Len(p$), 1) <> "\" Then
            fnPath$ = p$ & "\"
        Else
            fnPath$ = p$
        End If
    End If
End Function

Sub FilePath(ByVal f$, path$, fname$, Optional ByVal noExt As Boolean)
    On Error Resume Next
    Dim k, r$
    k = InStr(f$, "\")
    If k = 0 Then
        k = InStr(f$, ":")
        If k = 0 Then
            path$ = ""
            fname$ = f$
        Else
            path$ = Mid$(f$, 1, 2)
            fname$ = Mid$(f$, 3)
        End If
    Else
        k = InStrRev(f$, "\")   ' first occurence of \ from end of string
        path$ = Mid$(f$, 1, k - 1)
        fname$ = Mid$(f$, k + 1)
        If noExt Then fname$ = StripExt$(fname$)
    End If
End Sub

Function StripExt$(ByVal t$)    ' strip off file extension
    On Error Resume Next        ' cannot just search for "." in long file name
    If InStr(t$, ".") = 0 Then
        StripExt$ = t$      ' no extension
    Else
        StripExt$ = Left$(t$, InStrRev(t$, ".") - 1)
    End If
End Function
